#!/usr/bin/python2


import string
import sys
from filefuncts import openTemplate
from filefuncts import getConfig



def printMainPage():
	"""Print the main blog input CGI page"""

	cgiPath = getConfig('cgipath')

	mainText = openTemplate('mainpage.txt', { 'CGIPATH' : cgiPath })

	printFinalPage(mainText)
        #print 'Content-type: text/html\n\n'
        #print mainText

        return()




def printPreviewPage(blSubject, blBody):
	"""Generate preview of blog posting"""

	cgiPath = getConfig('cgipath')

	escBody = string.replace(blBody,'<','&lt;')
	escBody = string.replace(escBody,'>','&gt;')
	blBody = string.replace(blBody,'\n','<br />\n')

	finalText = openTemplate('preview.txt', {'CGIPATH' : cgiPath, 'blSubject' : blSubject, 'blBody' : blBody, 'escBody' : escBody})

	printFinalPage(finalText)
        #print 'Content-type: text/html\n\n'
        #print finalText

        return()




def printFinalPage(pageContent):
	"""Open the main template file, insert the supplied data
	and display the page in the browser"""

	import re

	docRoot = getConfig('templatepath')

	fp = open('%s/template.html' % docRoot)
	fullTemplate = string.join(fp.readlines(), '')
	fp.close()
	
	tPat = re.compile(r'<title>([^<]*)</title>')
	titleMatch = tPat.search(pageContent)
	if titleMatch:
		pageTitle = titleMatch.group(1)
		pageContent = string.replace(pageContent, '<title>%s</title>' % pageTitle, '')
	else:
		pageTitle = 'Sajjad\'s Blog'

	finalPage = string.replace(fullTemplate, '#INSERT_BODY_HERE#', pageContent)
	finalPage = string.replace(finalPage, '#PUT_TITLE_HERE#', pageTitle)

        print 'Content-type: text/html\n\n'
        print finalPage
	return()





def printRedirPage(redirURL):
	"""Redirect to specified page"""

	mainPageRedirect = openTemplate('redirect.txt', { 'redirURL' : redirURL })

        print 'Content-type: text/html\n\n'
	print mainPageRedirect
	sys.exit(0)
        return()



