#!/usr/bin/python2

import string
import sys
import os


def parseShellCmd():
	"""If command line arguments are given, parse them and return the
	results. This seems to work, but all the required options must
	be given"""

	from getopt import getopt
	import re

	allCmdArgs = sys.argv
	cmdUsage = 'Usage: %s [OPTIONS]\n\
Command line blog entries.\n\
   -h, --help			display this help and exit\n\
   -s, --subject=SUBJECT	Use this as the subject of the blog entry\n\
   -c, --category=CATEGORY	The posting belongs to this category\n\
   -b, --blogdata=DATA		The content of the blog entry\n\
   -f, --file=FILENAME		Read this file and use contents as blog body' % sys.argv[0]
	allCmdArgs.pop(0)
	shortCmdOpts = "hs:c:b:f:"
	longCmdOpts = ['help','subject=','category=','blogdata=','file=']
	try:
		opts, args = getopt(allCmdArgs,shortCmdOpts,longCmdOpts)
		for opt, val in opts:
			if opt == "-h" or opt == "--help":
				sys.exit(1)
			if opt == "-s" or opt == "--subject":
				blSubject = val
			if opt == "-c" or opt == "--category":
				blCategory = val
			if opt == "-b" or opt == "--blogdata":
				blBody = val
			if opt == "-f" or opt == "--file":
				blFile = val
				try:
					bf = open(blFile)
					blBody = string.join(bf.readlines(),'')
					bf.close()
				except:
					print 'Error opening blog file %s' % blFile
					sys.exit(1)
	except:
		print cmdUsage
		sys.exit(1)

	# Try to get the blog's subject from <subject> tags in the blog
	# body.
	sPat = re.compile(r'<subject>([^<]*)</subject>')
	cPat = re.compile(r'<category>([^<]*)</category>')
        subjectMatch = sPat.search(blBody)
        if subjectMatch:
                blSubject = subjectMatch.group(1)
                blBody = string.replace(blBody, '<subject>%s</subject>' % blSubject, '')

	categMatch = cPat.search(blBody)
	if categMatch:
		blCategory = categMatch.group(1)
		blBody = string.replace(blBody, '<category>%s</category>' % blCategory, '')

	return(blSubject, blCategory, blBody)



def promptForData():
	"""Get blog subject and body interactively through the
	shell"""

	import tempfile

	blSubject = raw_input('Enter Subject: ')
	blCategory = raw_input('Enter Category (default "General"): ')
	if blCategory == '':
		blCategory = 'General'

	bodyFile = tempfile.mktemp(".pyl")

	os.system('vim %s' % bodyFile)

	try:
		fd = open(bodyFile)
		blBody = string.join(fd.readlines(),'')
		fd.close()

		os.unlink(bodyFile)
	except:
		print "Unable to open file"
		blBody = raw_input('Enter Body of Entry:\n')

	print
	print
	print 'You entered the following:'
	print
	print 'Subject: %s' % blSubject
	print 'Category: %s' % blCategory 
	print 'Body:\n%s' % blBody
	print
	confirmResponse = raw_input('Enter y to continue: ')

	if confirmResponse == 'y':
		return(blSubject, blCategory, blBody)
	else:
		sys.exit(0)
	return()


