#!/usr/bin/python2

# PyLogger (comments.py)
#
# Tool to add comments to a site. It may seem more complex than
# it needs to be, but I had to do all this because of some
# limitations on Pair.
#
# Written by A.Sajjad Zaidi (http://www.sajjadzaidi.com/)
# Copyright April 2003
#


import os,sys
import string
from string import atoi
import re
from filefuncts import openTemplate
from filefuncts import getConfig
from filefuncts import getTimes
from filefuncts import getIndexData
from cgilogger import printFinalPage
from cgilogger import printRedirPage
import processWeb




def parseCGIForm():
	"""Parse CGI Form and display main page if no arguments given"""

	blogURL = getConfig('blogurl')
	docRoot = getConfig('testroot')

	import cgi

	form = cgi.FieldStorage()

	# Preview is always dynamic
	if form.has_key('preview'):
		if not form.has_key('email'):
			senderEmail = ''
		else:
			senderEmail = form['email'].value
		if not form.has_key('url'):
			senderURL = ''
		else:
			senderURL = form['url'].value
		if not form.has_key('sender'):
			commentSender = 'Anonymous'
		else:
			commentSender = form['sender'].value
		if not form.has_key('comment'):
			commentBody = ''
		else:
			commentBody = form['comment'].value
		entryID = form['blid'].value
		displayCommentPage(entryID, commentSender, senderEmail, senderURL, commentBody)
	# blogid only appears if the comment link is clicked so
	# just display the current comments or display dynamic comment form
	elif form.has_key('blogid'):
		blogID = form['blogid'].value
		blogYear = getIndexData(blogID, 'year')
		blogMonth = getIndexData(blogID, 'month')
		commentFileName = '%s/%s/%s/comments-%s.pyl' %(docRoot,blogYear,blogMonth,blogID)
		if os.path.exists(commentFileName):
			commentURL = '%s/%s/%s/comments-%s.html' %(blogURL,blogYear,blogMonth,blogID)
			printRedirPage(commentURL)
		else:
			displayCommentPage(blogID,'', '', '', '')
	elif form.has_key('confirm'):
		if not form.has_key('email'):
			senderEmail = ''
		else:
			senderEmail = form['email'].value
		if not form.has_key('url'):
			senderURL = ''
		else:
			senderURL = form['url'].value
		if not form.has_key('sender'):
			commentSender = 'Anonymous'
		else:
			commentSender = form['sender'].value
		if not form.has_key('comment'):
			commentBody = ''
		else:
			commentBody = form['comment'].value
		entryID = form['blid'].value
		postComment(entryID, commentSender, senderEmail, senderURL, commentBody)
	else:
		printRedirPage('%s' % blogURL)
	return()




def getBlogBody(blogID):
	"""Open the existing file and get the body of the blog
	from it"""

	docRoot = getConfig('testroot')

	blogYear = getIndexData(blogID, 'year')
	blogMonth = getIndexData(blogID, 'month')
	blogFileName = "%s/%s/%s/index.pyl" % (docRoot,blogYear, blogMonth)

	fp = open(blogFileName)
	fullFile = string.join(fp.readlines(),'')
	fp.close()

	blogPat = re.compile(r'<a name="%s"></a>\s*<p><b>([^<]*)</b><br></br>(.*?)<p class="blogend">([^<]+)<' % blogID, re.DOTALL)
	allMatches = blogPat.search(fullFile)
	if allMatches:
		blogSubject = allMatches.group(1)
		fullBlogEntry = allMatches.group(2)
		timeStamp = allMatches.group(3)
	else:
		printFinalPage("<p>Sorry, no blog entry with that ID was found</p>")

	return(blogSubject,fullBlogEntry,timeStamp)



def displayCommentPage(entryID, commentSender, senderEmail, senderURL, commentBody):
	"""Generate preview of the final blog"""

	cgiPath = getConfig('cgipath')

	blogSubject,fullBlogEntry,blogTimeStamp = getBlogBody(entryID)

	escBody = string.replace(commentBody,'<','&lt;')
	escBody = string.replace(escBody,'>','&gt;')

	commentBody = string.replace(commentBody,'\n','<br />\n')
	todaysDate,currentTime = getTimes('comment')

	blogYear = getIndexData(entryID, 'year')
	blogMonth = getIndexData(entryID, 'month')
	fullDate = getIndexData(entryID, 'date')

	if commentBody == '':
		divSection = ''
	else:
		divSection = openTemplate('commenthtml.txt', {
'todaysDate' : todaysDate,
'currentTime' : currentTime,
'senderURL' : senderURL,
'commentSender' : commentSender,
'commentBody' : commentBody
})

	previewPage = openTemplate('commentpage.txt', {
'entryID' : entryID,
'fullDate' : fullDate,
'blogSubject' : blogSubject,
'fullBlogEntry' : fullBlogEntry,
'blogTimeStamp' : blogTimeStamp,
'divSection' : divSection,
'CGIBASEURL' : cgiPath,
'entryID' : entryID,
'commentSender' : commentSender,
'senderEmail' : senderEmail,
'senderURL' : senderURL,
'escBody' : escBody
})

	printFinalPage(previewPage)
        return()



def postComment(blID, commentSender, senderEmail, senderURL, commentBody):
	"""Get input from somewhere and insert it in the main page, together with
	the time stamp"""

	docRoot = getConfig('testroot')
	blogURL = getConfig('blogurl')
	cgiPath = getConfig('cgipath')
	mailNotice = getConfig('mailcommentnotice')

	todaysDate,currentTime = getTimes('comment')

	commentBody = string.replace(commentBody,'\n','<br></br>\n')
	commentHTML = openTemplate('commenthtml.txt', {
'todaysDate' : todaysDate,
'currentTime' : currentTime,
'senderURL' : senderURL,
'commentSender' : commentSender,
'commentBody' : commentBody
})

	blogYear = getIndexData(blID, 'year')
	blogMonth = getIndexData(blID, 'month')
	fullDate = getIndexData(blID, 'date')
	commentFileName = '%s/%s/%s/comments-%s.pyl' %(docRoot,blogYear,blogMonth,blID)
	commentURL = '%s/%s/%s/comments-%s.html' %(blogURL,blogYear,blogMonth,blID)

	if os.path.exists(commentFileName):
		c = open(commentFileName)
		oldComments = string.join(c.readlines(),'')
		c.close()
		newData = string.replace(oldComments,'<!-- NEW COMMENTS GO HERE -->',commentHTML)
		n = open(commentFileName,'w')
		n.write(newData)
		n.close()
	else:
		blogSubject,fullBlogEntry,blogTimeStamp = getBlogBody(blID)
		fullHTMLBlock = openTemplate('commentblock.txt', {
'blID' : blID,
'fullDate' : fullDate,
'blogSubject' : blogSubject,
'fullBlogEntry' : fullBlogEntry,
'blogTimeStamp' : blogTimeStamp,
'commentHTML' : commentHTML,
'cgiPath' : cgiPath
})

		c = open(commentFileName, 'w')
		c.write(fullHTMLBlock)
		c.close()

	incrementCommentLink(blID)
	processWeb.tmplGen()
	#webUpdateCommand = 'sudo -u sajjad /home/sajjad/bin/webupdate.py'
	#try:
	#	upd = os.popen(webUpdateCommand)
	#	upd.close()
	#except:
	#	print

	if mailNotice == '1':
		mailComment(blID, commentSender, senderEmail, commentURL)

	printRedirPage(commentURL)
	return()





def mailComment(blID, senderName, senderEmail, commentURL):
	"""Mail the commentor's info and the URL to the comment
	page to the admin"""

	import smtplib

	mailBody = '''
Comment from %s on blog entry %s:

%s
''' %(senderName, blID, commentURL)

	smtpServer = 'localhost'
	if senderEmail == '':
		senderEmail = 'webmaster@zaidi.jp'
	fromAddress = '%s' % senderEmail
	toAddress = 'sajjad@zaidi.jp'
	mailSubject = 'Comment from %s' % senderName

	fullMessage = '''From: %s
To: %s
Cc: 
Bcc: 
Subject: %s 
Reply-To: 

%s
''' %(fromAddress, toAddress, mailSubject, mailBody)
	try:
		server = smtplib.SMTP('%s' % smtpServer)
		server.sendmail('%s' % fromAddress, '%s' % toAddress, fullMessage)
		server.quit
	except:
		printFinalPage('<p>Error sending comment. Please contact the webmaster</p>')
	return()




def incrementCommentLink(blID):
	"""Update the comment link on the main page to
	display the number of comments received"""

	docRoot = getConfig('testroot')

	blogYear = getIndexData(blID, 'year')
	blogMonth = getIndexData(blID, 'month')
	blogFileName = "%s/%s/%s/index.pyl" % (docRoot,blogYear, blogMonth)

	fp = open(blogFileName)
	fullFile = string.join(fp.readlines(),'')
	fp.close()

	comPat = re.compile(r'blogid=%s">Comments(.*?)</a>' % blID, re.DOTALL)
	comMatch = comPat.search(fullFile)
	if comMatch:
		matchResult = comMatch.group(1)
		if matchResult == '':
			newCommentNo = 1
			fullFile = string.replace(fullFile,'blogid=%s">Comments</a>' %(blID),'blogid=%s">Comments(%s)</a>' %(blID, newCommentNo))
		else:
			matchResult = string.replace(matchResult,'(','')
			matchResult = string.replace(matchResult,')','')
			oldCommentNo = atoi(matchResult)
			newCommentNo = oldCommentNo + 1
			fullFile = string.replace(fullFile,'blogid=%s">Comments(%s)</a>' %(blID, oldCommentNo),'blogid=%s">Comments(%s)</a>' %(blID, newCommentNo))
		c = open(blogFileName,'w')
		c.write(fullFile)
		c.close()
	return()



###########################################
##                 Start                 ##
###########################################

# Check how we were accessesd
if os.environ.has_key("GATEWAY_INTERFACE"):
	parseCGIForm()

sys.exit(0)

