#!/usr/bin/python2

import re
import os
import string
from string import atoi

def getConfig(optionName):
	"""Open the conf file and read the list of config options. Return the value for the one queried."""

	confFile = '/home/sajjad/work/pylogger/test/pylogger.conf'

	try:
		c = open(confFile)
		readFile = c.readlines()
		c.close()
	except:
		print 'Error opening conf file %s' % confFile
		sys.exit(1)

	cPat = re.compile(r'(^%s) \"?([^\"]*)\"?' % optionName)
	for l in readFile:
		cMatch = cPat.search(l)
		if cMatch:
			optionValue = cMatch.group(2)

	return (optionValue)




def openTemplate(tmpName, replacements):
	"""Do a search and replace on the given template and return the final text"""

	templatePath = getConfig('templatepath')

	f = open('%s/%s' % (templatePath,tmpName))
	pText = string.join(f.readlines(),'')
	f.close()

	finalText = pText % replacements

	return(finalText)




def getTimes(timeType):
	"""Generate the desired date and time formats for the blog entry"""

	import time

	dayOfWeek = time.strftime("%A", time.localtime(time.time()))

	currentHour = time.strftime("%H", time.localtime(time.time()))
	if atoi(currentHour) < 12:
		timeSuffix = 'am'
	else:
		timeSuffix = 'pm'

	currentMinute = time.strftime("%M", time.localtime(time.time()))

	dayOfMonth = time.strftime("%d", time.localtime(time.time()))
	if atoi(dayOfMonth) < 10:
		dayOfMonth = string.replace(dayOfMonth,'0','')
	if dayOfMonth == '1':
		dayOfMonth = '1st';
	elif dayOfMonth == '2':
		dayOfMonth = '2nd';
	elif dayOfMonth == '3':
		dayOfMonth = '3rd';
	elif dayOfMonth == '21':
		dayOfMonth = '21st';
	elif dayOfMonth == '22':
		dayOfMonth = '22nd';
	elif dayOfMonth == '23':
		dayOfMonth = '23rd';
	elif dayOfMonth == '31':
		dayOfMonth = '31st';
	else:
		dayOfMonth = '%sth' % dayOfMonth
	monthOfYear = time.strftime("%B", time.localtime(time.time()))
	decimalYear = time.strftime("%Y", time.localtime(time.time()))
	shortMonth = time.strftime("%b", time.localtime(time.time()))

	blogTime = '%s:%s%s' % (currentHour, currentMinute, timeSuffix)

	if timeType == 'newblog':
		blogDate = '%s %s %s %s' % (dayOfWeek, dayOfMonth, monthOfYear, decimalYear)
	elif timeType == 'comment':
		blogDate = '%s %s %s' % (dayOfMonth, monthOfYear, decimalYear)
		return(blogDate, blogTime)
	else:
		blogDate = '%s %s %s' % (dayOfMonth, monthOfYear, decimalYear)

	return(blogDate, blogTime, shortMonth, decimalYear)


def getIndexData(serialID, dataType):
	"""Open index file and get the required info
	This could be replaced by a call to a database"""

	indexPat = re.compile(r'%s,"([^,]*)","([^,]*)","([^,]*)"' % serialID)

	indexFile = getConfig('blogindex')

	fp = open(indexFile)
	blogRecord = fp.readline()
	while blogRecord:
		idxMatch = indexPat.search(blogRecord)
		if idxMatch:
			blogDate = idxMatch.group(1)
			blogTime = idxMatch.group(2)
			blogSubject = idxMatch.group(3)
			break
		blogRecord = fp.readline()
	fp.close()
	
	if dataType == 'time':
		return(blogTime)
	elif dataType == 'subject':
		return(blogSubject)
	elif dataType == 'date':
		return(blogDate)
	elif dataType == 'year':
		datePat = re.compile(r'\w* \d*\w\w \w+ (\d*)')
		dateMatch = datePat.search(blogDate)
		if dateMatch:
			blYear = dateMatch.group(1)
		else:
			blYear = '2003'
		return(blYear)
	elif dataType == 'month':
		datePat = re.compile(r'\w* \d*\w\w (\w\w\w)\w* \d*')
		dateMatch = datePat.search(blogDate)
		if dateMatch:
			blMonth = string.lower(dateMatch.group(1))
		else:
			blMonth = 'nov'
		return(blMonth)
	else:
		return('')

