#!/usr/bin/python2

import os, string
from filefuncts import getConfig


def tmplGen():
	"""Generate HTML files from recently changed .pyl files and the given template"""

	# This function could use a rewrite

	import shutil
	import re

	# Place where the final files will be generated
	localWebRoot = getConfig('localroot')
	# Directory with the edited templates
	testWebRoot = getConfig('testroot')
	templateRoot = getConfig('templatepath')

	# Store the template in string to be used later
	os.chdir('%s' % testWebRoot)

	templateFile = '%s/template.html' % templateRoot

	t = open('%s' % templateFile)
	readTemplate = t.readlines()
	orgTemplate = string.join(readTemplate, '')
	t.close()

	# Get list of all files ending in .pyl
	l = os.popen('find * \( -type f -or -type l \) -mtime -1 -name "*.pyl"')
	allFiles = l.readlines()
	allFiles.append('index.pyl')
	strpFileNames = [ string.strip(blogFileName) for blogFileName in allFiles ]

	tPat = re.compile(r'<title>([^<]*)</title>')

	# Directory exist pattern
	dPat = re.compile(r'^(.*)/[^/]*.html')

	# Replace the '#INSERT_BODY_HERE#' in the template with the new data and
	# write it out to the final location
	for blogFileName in strpFileNames:
		fullTemplate = orgTemplate
		f = open('%s' % blogFileName)
		readBlog = f.readlines()
		fullBlogBody = string.join(readBlog, '')
		f.close()

		# Check if the template contains <title> tags. Set
		# it to "Sajjad's Blog" if it doesn't
		titleMatch = tPat.search(fullBlogBody)
		if titleMatch:
			pageTitle = titleMatch.group(1)
			fullBlogBody = string.replace(fullBlogBody, '<title>%s</title>' % pageTitle, '')
		else:
			pageTitle = 'Sajjad\'s Blog'

		newBody = string.replace(fullTemplate, '#INSERT_BODY_HERE#', fullBlogBody)
		newBody = string.replace(newBody, '#PUT_TITLE_HERE#', pageTitle)

		newName = '%s/%s' % (localWebRoot, string.replace('%s' % blogFileName, '.pyl', '.html'))

		# Check if the target directory exists and create it if
		# it doesn't
		dirNameMatch = dPat.search(newName)
		if dirNameMatch:
			newDirName = dirNameMatch.group(1)
			if not os.path.exists(newDirName):
				os.makedirs(newDirName)

		n = open('%s' % newName, 'w')
		n.write(newBody)
		n.close()

	return()


def runRsync():
	"""Update the web tree using rsync if on a remote server"""

	# Full update through rsync and ssh
	fullWebRoot = '/home/sajjad/work/ahlebait.jp'

	os.chdir('%s' % fullWebRoot)
	updateWeb = os.popen('rsync -Cave ssh --delete . sajjad@wanote.pair.com:public_html')

	updateOutput = string.join(updateWeb.readlines(),'')

	print updateOutput
	return()

if __name__ == '__main__':
	tmplGen()
